<template>
  <a-form ref="formRef" :model="vdata.currentConfig" layout="vertical" :rules="vdata.formRules">
    <a-row :gutter="16">
      <a-col span="24">
        <a-form-item :label="getShowName() + '小程序支付跳转的选择'" name="isUseSubmchAccount">
          <a-radio-group v-model:value="vdata.currentConfig.isUseSubmchAccount">
            <a-radio :value="0">服务商小程序</a-radio>
            <a-radio :value="1">特约商户自己的小程序</a-radio>
          </a-radio-group>
        </a-form-item>
      </a-col>

      <template v-if="vdata.currentConfig.isUseSubmchAccount == 1">
        <a-col span="12">
          <a-form-item :label="getShowName() + '的小程序AppID'" name="liteAppId">
            <a-input v-model:value="vdata.currentConfig['liteAppId']" placeholder="请输入" @change="changeFun('liteAppId')" />
          </a-form-item>
        </a-col>
        <a-col span="12">
          <a-form-item :label="getShowName() + '的小程序appSecret'" name="liteAppSecret">
            <a-input v-model:value="vdata.currentConfig.liteAppSecret" :placeholder=" vdata.encryptionField.liteAppSecret || '请输入小程序appSecret' " @change="changeFun('liteAppSecret')" />
          </a-form-item>
        </a-col>

        <a-divider dashed />

        <a-col span="12">
          <a-form-item :label="getShowName() + '的小程序原始ID'" name="liteGhid">
            <a-input v-model:value="vdata.currentConfig['liteGhid']" placeholder="请输入" @change="changeFun('liteGhid')" />
          </a-form-item>
        </a-col>
        <a-col span="12">
          <a-form-item :label="getShowName() + '的小程序版本'" name="liteEnv">
            <a-radio-group v-model:value="vdata.currentConfig.liteEnv">
              <a-radio value="release">正式</a-radio>
              <a-radio value="test">开发</a-radio>
              <a-radio value="preview">体验</a-radio>
            </a-radio-group>
          </a-form-item>
        </a-col>
        <a-col span="12">
          <a-form-item :label="getShowName() + '的小程序路径'" name="litePagePath">
            <a-input v-model:value="vdata.currentConfig.litePagePath" placeholder="请输入" @change="changeFun('litePagePath')" />
          </a-form-item>
        </a-col>
      </template>
    </a-row>
  </a-form>
</template>
<script setup lang="ts">
import { ref, reactive, defineProps, defineExpose } from 'vue'

// 当前的form
const formRef = ref()

// 定义父组件的传值
const props = defineProps({
  configMode: { type: String, default: '' }, // 支付接口
})

const vdata : any = reactive({

  // 定义加密的字段
  encryptionField : {
    liteAppSecret: ''
  },

  currentConfig: {} as any, // 当前配置项

  //表单规则
  formRules: {
    // liteAppId: [{ required: true, message: '请输入应用AppID', trigger: 'blur' }],
  }
})


function getShowName(){
  return '特约商户'
}


// 对外提供的页面的渲染函数 （ currentConfig = 当前配置项 ）
function pageRender(currentConfig){

  // 赋值
  vdata.currentConfig = currentConfig
  if(typeof vdata.currentConfig.isUseSubmchAccount == 'undefined'){ // 模式使用服务商
    vdata.currentConfig.isUseSubmchAccount = 0
  }

  // 处理加密数据字段
  Object.keys(vdata.encryptionField).forEach(key => {
    vdata.encryptionField[key] = vdata.currentConfig[key]
    delete vdata.currentConfig[key]
  })

  // 重置form验证
  if (formRef.value !== undefined && formRef.value !== null) {
    formRef.value.resetFields()
  }

}

// 对外提供的获取配置参数函数 （返回JSON类型）
function getConfigParams(){

  return formRef.value.validate().then( () => {
    return convertEncryData()
  })

}

// 转换加密数据
function convertEncryData(){

  // 对象克隆
  let result = Object.assign({}, vdata.currentConfig)
  Object.keys(vdata.encryptionField).forEach(key => {
    // 加密数据 && 空串
    if (!result[key]) {
      delete result[key]
    }
  })
  return result
}

// 消除参数空格
function changeFun(value) {
  if(vdata.currentConfig[value]) {
    vdata.currentConfig[value] = vdata.currentConfig[value].trim()
  }
}

defineExpose({ getConfigParams, pageRender })

</script>
